﻿
namespace Yuuna.Contracts.Test
{
    using Microsoft.AspNetCore;
    using Microsoft.AspNetCore.Builder;
    using Microsoft.AspNetCore.Hosting;
    using Microsoft.AspNetCore.Http;
    using Microsoft.AspNetCore.Routing;
    using Microsoft.Extensions.DependencyInjection;
    using System;
    using System.Collections.Concurrent;
    using System.Collections.Generic;
    using System.Text;
    using System.Threading.Tasks;
    using Yuuna.Contracts.Interaction;

    public class ViewService : IInteractiveView2
    {
        private ConcurrentQueue<string> _taskQueue;

        public ViewService()
        {
            this._taskQueue = new ConcurrentQueue<string>();

            WebHost
                .CreateDefaultBuilder()
                .UseStartup<Startup>()
                .Build()
                .Run();
        }
        public Response Request(string text)
        {
            //接收到從客戶端來的文字
            return null;
        } 
    }

    public class Startup
    {
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddRouting();
        }
        public void Configure(IApplicationBuilder app)
        {
            var defaultRouteHandler = new RouteHandler(context =>
            {
                var routeValues = context.GetRouteData().Values;
                return context.Response.WriteAsync($"Route values: {string.Join(", ", routeValues)}");
            });

            var routeBuilder = new RouteBuilder(app, defaultRouteHandler);
            routeBuilder.MapRoute("default", "{first:regex(^(default|home)$)}/{second?}");
            
            routeBuilder.MapPost("user/{text}", context => {
                var text = context.GetRouteValue("text");
                return context.Response.WriteAsync($"Create user. name: {name}");
            });

            var routes = routeBuilder.Build();
            app.UseRouter(routes);
        }


    } 
}
